<?php
/**
 * Alpus Addons Extend
 *
 * @author     AlpusTheme
 * @package    Alpus Core
 * @subpackage Core
 * @since      1.0
 */

defined( 'ABSPATH' ) || die;

if ( ! class_exists( 'Alpus_Addons_Extend' ) ) {
	class Alpus_Addons_Extend extends Alpha_Base {

		/**
		 * The Constructor
		 *
		 * @since 1.0
		 */
		public function __construct() {
			add_action( 'alpha_framework_addons', array( $this, 'extend_addons' ) );
			$this->addons_compatibility();
		}

		/**
		 * Extend Addons
		 *
		 * @since 1.0
		 *
		 */
		public function extend_addons( $request ) {
			// @start feature: fs_addon_studio
			if ( alpha_get_feature( 'fs_addon_studio' ) ) {
				if ( ( current_user_can( 'edit_posts' ) || current_user_can( 'edit_pages' ) ) &&
				( $request['doing_ajax'] || $request['is_preview'] || 'edit.php' == $GLOBALS['pagenow'] && isset( $_REQUEST['post_type'] ) && ALPHA_NAME . '_template' == $_REQUEST['post_type'] || 'post.php' == $GLOBALS['pagenow'] && 'edit' == $_REQUEST['action'] || 'post-new.php' == $GLOBALS['pagenow'] ) ) {
					require_once alpha_core_framework_path( ALPHA_CORE_ADDONS . '/studio/class-alpha-studio-extend.php' );
				}
			}
			// @end feature: fs_addon_studio
		}

		/**
		 * Addons Compatiblity
		 *
		 * @since 1.0
		 *
		 */
		public function addons_compatibility() {
			$addons = apply_filters(
				'alpha_addons_compatiblity',
				array(
					'product-compare',
					'product-brand',
					'post-like',
				)
			);
			foreach ( $addons as $addon ) {
				require_once ALPHA_CORE_INC . '/addons/alpus-' . $addon . '/class-alpus-' . $addon . '-extend.php';
			}
		}
	}
}

Alpus_Addons_Extend::get_instance();
