<?php
/**
 * Alpha Elementor Floating Addon
 *
 * @author     AlpusTheme
 * @package    Alpus Core
 * @subpackage Core
 * @version    1.0.0
 */

defined( 'ABSPATH' ) || exit;


use Elementor\Controls_Manager;

if ( ! class_exists( 'Alpha_Mask_Elementor' ) ) {
	/**
	 * Alpha Elementor Floating Addon
	 *
	 * @since 1.0.0
	 */
	class Alpha_Mask_Elementor extends Alpha_Base {

		/**
		 * The Constructor.
		 *
		 * @since 1.0.0
		 */
		public function __construct() {
			// Add controls to addon tab
			add_action( 'alpha_elementor_addon_controls', array( $this, 'add_controls' ), 10, 2 );

		}

		/**
		 * Add controls to addon tab.
		 *
		 * @since 1.0.0
		 */
		public function add_controls( $self, $source = '' ) {

			if ( 'banner' != $source ) {
				$self->start_controls_section(
					'_alpha_section_mask',
					array(
						'label' => esc_html__( 'Mask', 'alpha-core' ),
						'tab'   => Alpha_Widget_Advanced_Tabs::TAB_CUSTOM,
					)
				);

				Alpha_Core_Elementor_Extend::purchase_elementor_addon_notice( $self, Controls_Manager::RAW_HTML, '', 'alpha_mask', array() );

				$self->end_controls_section();
			}
		}
	}
	Alpha_Mask_Elementor::get_instance();
}
