<?php
/**
 * Alpha WooCommerce plugin compatibility.
 *
 * @author     AlpusTheme
 * @package    Alpus Core
 * @subpackage Core
 * @since      1.0
 */

use Elementor\Controls_Manager;

defined( 'ABSPATH' ) || die;

class Alpha_Core_WooCommerce_Extend extends Alpha_Base {

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	public function __construct() {
		if ( ! empty( $_REQUEST['action'] ) && 'elementor' == $_REQUEST['action'] && is_admin() ) {
			add_action( 'init', array( $this, 'init' ), 8 );
		} else {
			$this->init();
		}
	}

	/**
	 * Init WooCommerce actions
	 *
	 * @since 1.0
	 * @access public
	 */
	public function init() {
		add_action(
			'alpha_after_framework',
			function() {
				remove_filter( 'alpha_breadcrumb_args', 'alpha_single_prev_next_product', 10 );
			}
		);
	}

}

Alpha_Core_WooCommerce_Extend::get_instance();
