<?php
/**
 *  Elementor Hotspot Widget
 *
 * @author     AlpusTheme
 * @package    Alpus Elementor Addon
 * @subpackage Addon
 * @since      1.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

use Elementor\Controls_Manager;
use Elementor\Core\Schemes\Color;
use Elementor\Group_Control_Typography;
use Elementor\Group_Control_Background;
use Elementor\Alpha_Controls_Manager;

class Alpha_Hotspot_Elementor_Widget extends \Elementor\Widget_Base {

	public function get_name() {
		return ALPHA_NAME . '_widget_hotspot';
	}

	public function get_title() {
		return esc_html__( 'Hotspot', 'alpus-elementor-addon' );
	}

	public function get_icon() {
		return 'alpha-elementor-widget-icon alpha-widget-icon-hotspot';
	}

	public function get_categories() {
		return array( 'alpha_addon_widget' );
	}

	public function get_keywords() {
		return array( 'hotspot', 'dot', 'banner' );
	}

	/**
	 * Get Style depends.
	 *
	 * @since 1.0
	 */
	public function get_style_depends() {
		wp_register_style( 'alpha-hotspot', ALPUS_ELEMENTOR_ADDON_URI . '/inc/widgets/hotspot/hotspot' . ( is_rtl() ? '-rtl' : '' ) . '.min.css', array(), ALPUS_ELEMENTOR_ADDON_VERSION );
		return array( 'alpha-hotspot' );
	}

	protected function register_controls() {
		alpha_elementor_hotspot_layout_controls( $this );
		alpha_elementor_hotspot_style_controls( $this );
	}

	protected function render() {
		$atts = $this->get_settings_for_display();
		require ALPUS_ELEMENTOR_ADDON_PATH . '/inc/widgets/hotspot/render-hotspot-elementor.php';
	}
}
