<?php //@codingStandardsIgnoreLine
extract( //@codingStandardsIgnoreLine
	shortcode_atts(
		array(
			'show_type'            => '',
			'show_icon'            => '',
			'is_sticky'            => 'yes',
			'hide_label'           => false,
			'tooltip_type'         => '',
			'container'            => false,
			'min_width'            => 991,
			'bg_color'             => '',
			'link_color'           => '',
			'link_bg_color'        => '',
			'link_acolor'          => '',
			'link_abg_color'       => '',
			'animation_type'       => '',
			'animation_duration'   => 1000,
			'animation_delay'      => 0,
			'sticky_nav_item_list' => '',
			'el_class'             => '',
		),
		$atts
	)
);

$style     = '';
$result    = '';
$nav_class = 'nav sticky-navs';
if ( $bg_color ) {
	$style = 'background-color:' . esc_attr( $bg_color ) . ';';
}

$options             = array();
$options['minWidth'] = (int) $min_width;
$options             = json_encode( $options );
$el_class           .= ' sticky-nav-container';

if ( 'yes' === $is_sticky ) {
	$el_class .= ' sticky-content';
}

$result .= '<div class="fix-top ' . esc_attr( $el_class ) . '"><div class="nav-wrapper" data-plugin-options="' . esc_attr( $options ) . '"';
if ( $style ) {
	$result .= ' style="' . $style . '"';
}
if ( $animation_type ) {
	$result .= ' data-appear-animation="' . esc_attr( $animation_type ) . '"';
	if ( $animation_delay ) {
		$result .= ' data-appear-animation-delay="' . esc_attr( $animation_delay ) . '"';
	}
	if ( $animation_duration && 1000 !== $animation_duration ) {
		$result .= ' data-appear-animation-duration="' . esc_attr( $animation_duration ) . '"';
	}
}
	$result .= '>';

$result .= '<div class="container">';

if ( 'vertical-nav' === $show_type ) {
	$nav_class .= ' vertical-nav';
	if ( $hide_label && 'rect-hover' === $tooltip_type ) {
		$nav_class .= ' rect-hover';
	}
}

if ( $hide_label ) {
	$nav_class .= ' hide-label';
}

$result .= '<ul class="' . esc_attr( $nav_class ) . '">';

if ( ! empty( $sticky_nav_item_list ) ) {
	ob_start();
	foreach ( $sticky_nav_item_list as $key => $atts ) {
		if ( isset( $atts['icon_cl'] ) && isset( $atts['icon_cl']['value'] ) ) {
			if ( isset( $atts['icon_cl']['library'] ) && isset( $atts['icon_cl']['value']['id'] ) ) {
				$atts['icon'] = $atts['icon_cl']['value']['id'];
			} else {
				$atts['icon'] = $atts['icon_cl']['value'];
			}
		}
		if ( isset( $atts['link'] ) && isset( $atts['link']['url'] ) ) {
			$atts['link'] = $atts['link']['url'];
		}
		extract( //@codingStandardsIgnoreLine
			shortcode_atts(
				array(
					'_id'           => '',
					'label'         => '',
					'tooltip'       => '',
					'link'          => '',
					'icon'          => '',
					'link_color'    => '',
					'link_bg_color' => '',
					'link_acolor'   => '',
					'el_class'      => '',
				),
				$atts
			)
		);

		$icon_class = $icon;

		if ( ! empty( $_id ) ) {
			$el_class = trim( $el_class . ' ' . 'elementor-repeater-item-' . $_id );
		}

		$output = '<li class="' . esc_attr( $el_class ) . '" title="' . esc_attr( $tooltip ) . '">';

		if ( $link ) {
			$output .= '<a href="' . esc_url( $link ) . '" class="sticky-nav-item">';
		} else {
			$output .= '<span class="sticky-nav-item">';
		}
		if ( ( $show_icon && $icon_class ) || $hide_label ) {
			$output .= '<i class="' . esc_attr( $icon_class ) . '"></i>';
		}

		if ( $label ) {
			$output .= '<span>' . esc_html( $label ) . '</span>';
		}

		if ( $link ) {
			$output .= '</a>';
		} else {
			$output .= '</span>';
		}

		$output .= '</li>';

		echo alpha_escaped( $output );
	}
	$result .= ob_get_clean();
} elseif ( ! empty( $content ) ) {
	$result .= do_shortcode( $content );
}

	$result .= '</ul>';

$result .= '</div>';

$result .= '</div></div>';

echo alpha_escaped( $result );
