/**
 *  Timeline Horizontal Library
 * 
 * @package    Alpus Elementor Addon
 * @subpackage Addon
 * @author     AlpusTheme
 * @since      1.0
 */

'use strict';

window.theme = window.theme || {};

( function ( $ ) {
    theme.initTimelineHorizontal = function ( selector ) {
        var $timeLine = $( selector ).find( '.timeline-line' );
        if ( $timeLine.length == 0 ) return;
        var $timeLineItem = $( selector ).find( '.timeline-list>*:first-child' );
        var width = 0;
        $timeLineItem.children().each( function () {
            width += this.clientWidth;
        } );
        $timeLine.css( 'width', 'calc(' + width + 'px - (2 * var(--alpha-gap)))' );
    }

    if ( 'undefined' !== typeof alpha_vars ) {
        $( window ).on( 'alpha_complete', function () {
            $( '.timeline-horizontal' ).each( function () {
                theme.initTimelineHorizontal( this );
            } );
        } );
    } else {
        $( document ).on( 'ready', function () {
            $( '.timeline-horizontal' ).each( function () {
                theme.initTimelineHorizontal( this );
            } );
        } );
    }
} )( jQuery );