<?php
/**
 * Alpha Pro Admin Page
 *
 * @author     AlpusTheme
 * @package    Alpus Pro
 * @subpackage Pro
 * @since      1.0
 */
defined( 'ABSPATH' ) || die;
if ( ! class_exists( 'Alpha_Pro_Admin' ) ) {
	class Alpha_Pro_Admin extends Alpha_Base {
		/**
		 * Constructor
		 *
		 * Add actions and filters for admin page.
		 *
		 * @since 1.0
		 */
		public function __construct() {
			// Toolbar / Activate Theme
			add_action( 'alpha_add_wp_toolbar_menu', array( $this, 'add_wp_toolbar_menu' ) );
		}

		/**
		 * Activate theme menu in toolbar
		 *
		 * @since 1.0
		 */
		public function add_wp_toolbar_menu() {
			$target = is_admin() ? '_self' : '_blank';

			// Activate Theme
			if ( ! Alpha_Admin::get_instance()->is_registered() ) {
				Alpha_Core_Admin::get_instance()->add_wp_toolbar_menu_item(
					'<span class="ab-icon dashicons dashicons-admin-network"></span><span class="ab-label">' . esc_html__( 'Activate Theme', 'alpha-pro' ) . '</span>',
					false,
					esc_url( admin_url( 'admin.php?page=alpha' ) ),
					array(
						'class'  => 'alpha-menu',
						'target' => $target,
					),
					'alpha-activate'
				);
			}
		}
	}
}

Alpha_Pro_Admin::get_instance();
