<?php
/**
 * Alpha Pro Layout Builder Admin
 *
 * @author     AlpusTheme
 * @package    Alpus Pro
 * @subpackage Pro
 * @since      1.0
 */

// Direct access is denied
defined( 'ABSPATH' ) || die;

if ( ! class_exists( 'Alpha_Pro_Layout_Builder_Admin' ) ) {
	class Alpha_Pro_Layout_Builder_Admin extends Alpha_Base {

		/**
		 * Conditions Map
		 *
		 * @since 1.0
		 * @access public
		 */
		public $conditions;

		/**
		 * Layouts array for different conditions.
		 *
		 * @since 1.0
		 * @access public
		 */
		public $schemes;

		/**
		 * Constructor
		 *
		 * @since 1.0
		 * @access public
		 */
		public function __construct() {
			if ( isset( $_REQUEST['page'] ) && 'alpha-layout-builder' == $_REQUEST['page'] ) {
				add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
			}
		}
		/**
		 * Enqueue scripts for layout builder.
		 *
		 * @since 1.0
		 * @access public
		 */
		public function enqueue_scripts() {
			if ( class_exists( 'Alpha_Admin' ) && Alpha_Admin::get_instance()->is_registered() ) {
				// Enqueue styles and scripts.
				wp_enqueue_script( 'alpha-pro-layout-builder-admin', ALPHA_PRO_INC_URI . '/admin/layout-builder/pro-layout-builder-admin' . ALPHA_JS_SUFFIX, array( 'jquery-core', 'alpha-layout-builder-admin' ), ALPHA_VERSION, true );
			}
		}
	}
}


/**
 * Setup Alpha Layout Builder
 *
 * @since 1.0
 */
Alpha_Pro_Layout_Builder_Admin::get_instance();
