<?php
/**
 * Alpha Pro Assets Class
 *
 * Enqueue pro assets including css, js and images.
 *
 * @author     AlpusTheme
 * @package    Alpus Pro
 * @subpackage Pro
 * @since      1.0
 */
defined( 'ABSPATH' ) || die;

class Alpha_Pro_Assets extends Alpha_Base {

	/**
	 * Constructor
	 *
	 * @since 1.0
	 * @access public
	 */
	public function __construct() {

		// Manage Theme and Plugin Assets

		add_action( 'alpha_vars', array( $this, 'register_vars' ) );

		add_action( 'wp_enqueue_scripts', array( $this, 'register_scripts' ), 1 );
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_styles' ), 20 );
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_scripts' ), 30 );
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_admin_scripts' ), 5 );
	}

	/**
	 * Register styles and scripts.
	 *
	 * @since 1.0
	 */
	public function register_scripts() {
		// Styles

		// Scripts
	}

	/**
	 * Enqueue styles and scripts for admin.
	 *
	 * @since 1.0
	 */
	public function enqueue_admin_scripts() {
	}

	/**
	 * Enqueue frontend styles.
	 *
	 * @since 1.0
	 */
	public function enqueue_styles() {
	}


	/**
	 * Enqueue frontend scripts and localize vars.
	 *
	 * @since 1.0
	 */
	public function enqueue_scripts() {
		if ( ! empty( $localize_vars['shop_ajax'] ) || ! empty( $localize_vars['blog_ajax'] ) ) {
			wp_enqueue_script( 'alpha-ajax' );
		}
	}

	/**
	 * Register localize vars
	 *
	 * @since 1.0
	 */
	public function register_vars( $localize_vars ) {
		if ( alpha_get_option( 'archive_ajax' ) && ( is_archive() || is_home() || is_search() ) && ! alpha_is_shop() ) {
			$localize_vars['blog_ajax'] = 1;
		}

		if ( class_exists( 'WooCommerce' ) && alpha_get_option( 'archive_ajax' ) && ! apply_filters( 'alpha_is_vendor_store', false ) && alpha_is_shop() ) {
			$localize_vars['shop_ajax'] = 1;
		}

		return $localize_vars;
	}
}

Alpha_Pro_Assets::get_instance();
