/**
 * Alpha Pro Elementor Admin
 * 
 * @package Alpus Pro
 * @since 1.0
 */

'use strict';

var themeElementorPro = window.themeElementorPro || {};

( function ( $ ) {
    themeElementorPro.activeSection = null;
    themeElementorPro.editedElement = null;

    themeElementorPro.init = function () {
        var self = this;

        self.initSideHeaderPreview();
        self.initFooterFixedPreview();
    }

    themeElementorPro.initSideHeaderPreview = function () {
        $( document )
            .on( 'change', '.elementor-control-header_pos select', function ( e ) {
                var iframejQuery = document.getElementById( 'elementor-preview-iframe' ).contentWindow.jQuery;
                if ( $( this ).val() ) {
                    iframejQuery( 'body' ).addClass( 'side-header' );
                    if ( !iframejQuery( '.custom-header' ).parent().hasClass( 'header-area' ) ) {
                        iframejQuery( '.custom-header' ).wrap( '<div class="header-area"></div>' );
                    }
                } else {
                    iframejQuery( 'body' ).removeClass( 'side-header' );
                    if ( iframejQuery( '.custom-header' ).parent().hasClass( 'header-area' ) ) {
                        iframejQuery( '.custom-header' ).unwrap( '.header-area' );
                    }
                }
            } )
            .on( 'change', '.elementor-control-side_header_breakpoint select', function ( e ) {
                var iframejQuery = document.getElementById( 'elementor-preview-iframe' ).contentWindow.jQuery;
                iframejQuery( 'body' ).removeClass( 'side-on-desktop side-on-tablet side-on-mobile' );
                if ( $( this ).val() ) {
                    iframejQuery( 'body' ).addClass( 'side-on-' + $( this ).val() );
                }
            } )
    }

    // Fixed Footer event
    themeElementorPro.initFooterFixedPreview = function () {
        $( document )
            .on( 'change', '.elementor-control-alpha_fixed_footer .elementor-switch-input', function ( e ) {
                var iframejQuery = document.getElementById( 'elementor-preview-iframe' ).contentWindow.jQuery;

                if ( $( this ).is( ':checked' ) ) {
                    iframejQuery( 'body' ).addClass( 'fixed-footer' );
                } else {
                    iframejQuery( 'body' ).removeClass( 'fixed-footer' );
                }
            } )
    }

    // Setup Alpha Elementor Admin
    elementor.on( 'frontend:init', themeElementorPro.init.bind( themeElementorPro ) );
} )( jQuery );
