<?php
/**
 * Alpha Pro Actions, Filters
 *
 * @author     AlpusTheme
 * @package    Alpus Pro
 * @subpackage Pro
 * @version    1.0
 */
add_filter( 'body_class', 'alpha_pro_add_body_class' );
add_filter( 'alpha_async_scripts', 'alpha_add_async_scripts' );
function alpha_add_async_scripts( $scripts ) {
	$scripts[] = 'alpha-pro';
	return $scripts;
}

if ( ! function_exists( 'alpha_pro_add_body_class' ) ) {
	/**
	 * Add classes to body
	 *
	 * @since 1.0
	 *
	 * @param array[string] $classes
	 *
	 * @return array[string] $classes
	 */
	function alpha_pro_add_body_class( $classes ) {
		global $alpha_layout;

		// Header Position
		$header = false;
		if ( alpha_get_feature( 'fs_pb_elementor' ) && defined( 'ELEMENTOR_VERSION' ) && isset( $alpha_layout['header'] ) && ! empty( get_post_meta( $alpha_layout['header'], '_elementor_data', true ) ) ) {
			$header = $alpha_layout['header'];
		}
		if ( ALPHA_NAME . '_template' == get_post_type() && 'header' == get_post_meta( get_the_ID(), ALPHA_NAME . '_template_type', true ) ) {
			$header = get_the_ID();
		}
		if ( $header ) {
			$settings = get_post_meta( $header, '_elementor_page_settings', true );
			if ( ! empty( $settings['header_pos'] ) ) {

				wp_enqueue_script( 'alpha-sidebar' );
				wp_enqueue_script( 'alpha-sticky-lib' );

				$classes[] = 'side-header';

				if ( ! empty( $settings['side_header_breakpoint'] ) ) {
					$classes[] = 'side-on-' . $settings['side_header_breakpoint'];
				}
			}
		}

		return $classes;
	}
}
